Bug 1002321 - Review Request: perl-File-KeePass - Interface to KeePass V1 and V2 database files
Review Request: perl-File-KeePass - Interface to KeePass V1 and V2 database f...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Eduardo Echeverria
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1002324
  Show dependency treegraph
 
Reported: 2013-08-28 17:59 EDT by Matias Kreder
Modified: 2014-03-03 10:27 EST (History)
7 users (show)

See Also:
Fixed In Version: perl-File-KeePass-2.03-3.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-09-21 04:34:04 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
echevemaster: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Matias Kreder 2013-08-28 17:59:07 EDT
Spec URL: http://fedorapeople.org/~delete/kpcli/perl-File-KeePass.spec
SRPM URL: http://fedorapeople.org/~delete/kpcli/perl-File-KeePass-2.03-1.fc20.src.rpm
Description: 
File::KeePass gives access to KeePass version 1 (kdb) and version 2 (kdbx)
databases.

Fedora Account System Username: delete

This is a dependency for another package I'm planning to upload (kpcli). I'm not a Fedora Packager yet, I need sponsorship.

Test Koji build:

[makerpm@builder ~]$ koji build --scratch f19 rpmbuild/SRPMS/perl-File-KeePass-2.03-1.fc20.src.rpm 
Uploading srpm: rpmbuild/SRPMS/perl-File-KeePass-2.03-1.fc20.src.rpm
[====================================] 100% 00:00:08  39.33 KiB   4.86 KiB/sec
Created task: 5866959
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=5866959
Watching tasks (this may be safely interrupted)...
5866959 build (f19, perl-File-KeePass-2.03-1.fc20.src.rpm): open (arm02-builder06.arm.fedoraproject.org)
  5866960 buildArch (perl-File-KeePass-2.03-1.fc20.src.rpm, noarch): open (buildvm-16.phx2.fedoraproject.org)
  5866960 buildArch (perl-File-KeePass-2.03-1.fc20.src.rpm, noarch): open (buildvm-16.phx2.fedoraproject.org) -> closed
  0 free  1 open  1 done  0 failed
5866959 build (f19, perl-File-KeePass-2.03-1.fc20.src.rpm): open (arm02-builder06.arm.fedoraproject.org) -> closed
  0 free  0 open  2 done  0 failed

5866959 build (f19, perl-File-KeePass-2.03-1.fc20.src.rpm) completed successfully
Comment 1 Christopher Meng 2013-08-28 21:56:11 EDT
Woo...

Double check:

License:        (GPL+ or Artistic) and (GPLv2+ or Artistic) and MIT and Public Domain and UCD


========================

1. Remove these:

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

rm -rf $RPM_BUILD_ROOT

find $RPM_BUILD_ROOT -depth -type d -exec rmdir {} 2>/dev/null \;


%clean
rm -rf $RPM_BUILD_ROOT

%defattr(-,root,root,-)

2. "%{__perl}" can just be "perl"

PERL_INSTALL_ROOT can be DESTDIR

3. What's this?

* Wed Aug 28 2013 = Matias Kreder <delete@fedoraprojecto.org> 2.03-1

"="?

4. You can drop the explicit version requires.

5. Package %description is not good.

Suggestion copied from CPAN:

File::KeePass gives access to KeePass version 1 (kdb) and version 2 (kdbx) databases.

The version 1 and version 2 databases are very different in construction, but the majority of information overlaps and many algorithms are similar. File::KeePass attempts to iron out as many of the differences.

File::KeePass gives nearly raw data access. There are a few utility methods for manipulating groups and entries. More advanced manipulation can easily be layered on top by other modules.

File::KeePass is only used for reading and writing databases and for keeping passwords scrambled while in memory. Programs dealing with UI or using of auto-type features are the domain of other modules on CPAN. File::KeePass::Agent is one example.
Comment 2 Ralf Corsepius 2013-08-28 23:27:51 EDT
> 2. "%{__perl}" can just be "perl"
Well, I am aware this is what some folks communicate, but I will never agree with this. It contradicts the principle of "reproducable builds":

Just try this
- Put a file named "perl" in ~/bin, containing this:
#!/bin/sh
exit 1
- export PATH=~/bin:$PATH
- run rpmbuild -ba <your package>.spec


Wrt. your package:

Don't use BR:'s on perl package names:
BuildRequires:  perl-Test-Simple

Likely, this should be perl(Test::Simple) or similar.
Comment 3 Matias Kreder 2013-08-29 16:50:25 EDT
Hi, I'm not clear about the license. The author says he wants to keep the same version as Perl. 

According to the perl spec (or rpm -qi perl), its license is:

License     : (GPL+ or Artistic) and (GPLv2+ or Artistic) and Copyright Only and MIT and Public Domain and UCD

It didn't allow me to put "Copyright Only" so I used the rest of the licenses.

I have uploaded a new .spec and .srpm file.

SPEC: http://fedorapeople.org/~delete/kpcli/perl-File-KeePass.spec
SRPM: http://fedorapeople.org/~delete/kpcli/perl-File-KeePass-2.03-2.fc20.src.rpm

Thank you for taking the time to review it.
Comment 4 Ralf Corsepius 2013-09-01 23:33:10 EDT
(In reply to Matias Kreder from comment #3)
> Hi, I'm not clear about the license. The author says he wants to keep the
> same version as Perl. 
> 
> According to the perl spec (or rpm -qi perl), its license is:
Well, what the perl-rpms spec says is very confusing and irrelevant wrt. this review (I for one consider this License: line to be non-sense).

Anywhy, What matter is upstream perl and upstream of this perl-dist.

This is what upstream perl tells: http://dev.perl.org/licenses/

=> GPL+ or Artistic

This is what several 100s of perl-modules/dists in Fedora use.

> License     : (GPL+ or Artistic) and (GPLv2+ or Artistic) and Copyright Only
> and MIT and Public Domain and UCD
> 
> It didn't allow me to put "Copyright Only" so I used the rest of the
> licenses.
Correct, "Copyright Only" isn't a license.
Comment 5 Matias Kreder 2013-09-02 12:52:30 EDT
Ralf, 

Thank you. I have re-uploaded the .spec and .src.rpm files.

SPEC: http://delete.fedorapeople.org/kpcli/perl-File-KeePass.spec
SRPM: http://delete.fedorapeople.org/kpcli/perl-File-KeePass-2.03-3.fc21.src.rpm
Comment 6 Eduardo Echeverria 2013-09-08 05:00:18 EDT
Hi Matias, package have some missing BR, that are necessary for the tests, these are:

- perl(XML::Parser)
- perl(Compress::Raw::Zlib)

See the warnings: 

PERL_DL_NONLAZY=1 /usr/bin/perl "-MExtUtils::Command::MM" "-e" "test_harness(0, 'blib/lib', 'blib/arch')" t/*.t
t/00_base.t ..... ok
# Failed to load library: Can't locate Compress/Raw/Zlib.pm in @INC (you may need to install the Compress::Raw::Zlib module) (@INC contains: /builddir/build/BUILD/File-KeePass-2.03/blib/lib /builddir/build/BUILD/File-KeePass-2.03/blib/arch /usr/local/lib64/perl5 /usr/local/share/perl5 /usr/lib64/perl5/vendor_perl /usr/share/perl5/vendor_perl /usr/lib64/perl5 /usr/share/perl5 .) at t/01_kdbx.t line 16.
t/01_kdbx.t ..... ok
# Failed to load library: Can't locate Compress/Raw/Zlib.pm in @INC (you may need to install the Compress::Raw::Zlib module) (@INC contains: /builddir/build/BUILD/File-KeePass-2.03/blib/lib /builddir/build/BUILD/File-KeePass-2.03/blib/arch /usr/local/lib64/perl5 /usr/local/share/perl5 /usr/lib64/perl5/vendor_perl /usr/share/perl5/vendor_perl /usr/lib64/perl5 /usr/share/perl5 .) at t/05_convert.t line 16.
t/05_convert.t .. ok

# Failed to load library: Can't locate XML/Parser.pm in @INC (you may need to install the XML::Parser module) (@INC contains: /builddir/build/BUILD/File-KeePass-2.03/blib/lib /builddir/build/BUILD/File-KeePass-2.03/blib/arch /usr/local/lib64/perl5 /usr/local/share/perl5 /usr/lib64/perl5/vendor_perl /usr/share/perl5/vendor_perl /usr/lib64/perl5 /usr/share/perl5 .) at t/01_kdbx.t line 15.
t/01_kdbx.t ..... ok
# Failed to load library: Can't locate XML/Parser.pm in @INC (you may need to install the XML::Parser module) (@INC contains: /builddir/build/BUILD/File-KeePass-2.03/blib/lib /builddir/build/BUILD/File-KeePass-2.03/blib/arch /usr/local/lib64/perl5 /usr/local/share/perl5 /usr/lib64/perl5/vendor_perl /usr/share/perl5/vendor_perl /usr/lib64/perl5 /usr/share/perl5 .) at t/05_convert.t line 15.
t/05_convert.t .. ok
Comment 7 Matias Kreder 2013-09-09 13:15:58 EDT
Eduardo,

Thank you. I had missed those errors. Please find the new version on:

SPEC: http://delete.fedorapeople.org/kpcli/perl-File-KeePass.spec
SRPM: http://delete.fedorapeople.org/kpcli/perl-File-KeePass-2.03-3.fc21.src.rpm

I also ran a test Koji build and didn't find any other error:

http://koji.fedoraproject.org/koji/taskinfo?taskID=5914660
http://kojipkgs.fedoraproject.org//work/tasks/4660/5914660/build.log

Regards
Matias
Comment 8 Eduardo Echeverria 2013-09-11 01:09:44 EDT
I will sponsor to Matias, lifting FE-NEEDSPONSOR 
 
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 1 files have unknown license. Detailed output of
     licensecheck in /home/makerpm/perl/1002321-perl-File-
     KeePass/licensecheck.txt
[-]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
* Any pel package that are licensed under the same license of perl are licensed under both the GPL and Artistic licenses, comment not required
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by:
     /usr/share/perl5/vendor_perl/File(perl-File-BaseDir, perl-Image-ExifTool,
     perl-File-DesktopEntry, perl-File-CheckTree, perl-File-MimeInfo, perl-
     File-Listing)
* As specified in the general Packaging Guidelines, perl packages are expected 
  to share ownership of certain directories
http://fedoraproject.org/wiki/Packaging:Perl#Directory_Ownership
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Perl:
[x]: Package contains the mandatory BuildRequires and Requires:.
[x]: CPAN urls should be non-versioned.

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.

+ make test
PERL_DL_NONLAZY=1 /usr/bin/perl "-MExtUtils::Command::MM" "-e" "test_harness(0, 'blib/lib', 'blib/arch')" t/*.t
t/00_base.t ..... ok
t/01_kdbx.t ..... ok
t/05_convert.t .. ok
All tests successful.
Files=3, Tests=179,  2 wallclock secs ( 0.05 usr  0.01 sys +  1.63 cusr  0.05 csys =  1.74 CPU)
Result: PASS

[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: perl-File-KeePass-2.03-3.fc20.noarch.rpm
          perl-File-KeePass-2.03-3.fc20.src.rpm
perl-File-KeePass.noarch: W: spelling-error %description -l en_US kdb -> kb, db, k db
perl-File-KeePass.noarch: W: spelling-error %description -l en_US kdbx 
perl-File-KeePass.src: W: spelling-error %description -l en_US kdb -> kb, db, k db
perl-File-KeePass.src: W: spelling-error %description -l en_US kdbx 
2 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint perl-File-KeePass
perl-File-KeePass.noarch: W: spelling-error %description -l en_US kdb -> kb, db, k db
perl-File-KeePass.noarch: W: spelling-error %description -l en_US kdbx 
1 packages and 0 specfiles checked; 0 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
perl-File-KeePass (rpmlib, GLIBC filtered):
    perl(:MODULE_COMPAT_5.18.1)
    perl(Crypt::Rijndael)
    perl(Digest::SHA)
    perl(constant)
    perl(strict)
    perl(warnings)



Provides
--------
perl-File-KeePass:
    perl(File::KeePass)
    perl-File-KeePass



Source checksums
----------------
http://www.cpan.org/authors/id/R/RH/RHANDOM/File-KeePass-2.03.tar.gz :
  CHECKSUM(SHA256) this package     : c30c688027a52ff4f58cd69d6d8ef35472a7cf106d4ce94eb73a796ba7c7ffa7
  CHECKSUM(SHA256) upstream package : c30c688027a52ff4f58cd69d6d8ef35472a7cf106d4ce94eb73a796ba7c7ffa7


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 1002321 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64


----------------

PACKAGE APPROVED

----------------

Follow the process from: 
https://fedoraproject.org/wiki/Join_the_package_collection_maintainers#Add_Package_to_Source_Code_Management_.28SCM.29_system_and_Set_Owner


If you have any questions , feel free to contact me through my email or in the irc channel #fedora-devel, my nick is echevemaster
Comment 9 Matías Kreder 2013-09-11 12:17:53 EDT
New Package SCM Request
=======================
Package Name: perl-File-KeePass
Short Description: Interface to KeePass V1 and V2 database files
Owners: delete echevemaster
Branches: f18 f19 f20 el5 el6
InitialCC:
Comment 10 Gwyn Ciesla 2013-09-11 12:46:34 EDT
Git done (by process-git-requests).
Comment 11 Fedora Update System 2013-09-11 16:45:43 EDT
perl-File-KeePass-2.03-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/perl-File-KeePass-2.03-3.fc19
Comment 12 Fedora Update System 2013-09-11 16:57:42 EDT
perl-File-KeePass-2.03-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/perl-File-KeePass-2.03-3.fc20
Comment 13 Fedora Update System 2013-09-11 17:09:30 EDT
perl-File-KeePass-2.03-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/perl-File-KeePass-2.03-3.fc18
Comment 14 Fedora Update System 2013-09-11 17:53:23 EDT
perl-File-KeePass-2.03-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/perl-File-KeePass-2.03-3.el6
Comment 15 Fedora Update System 2013-09-12 21:08:06 EDT
perl-File-KeePass-2.03-3.fc19 has been pushed to the Fedora 19 testing repository.
Comment 16 Ralf Corsepius 2013-09-12 23:22:38 EDT
(In reply to Matías Kreder from comment #9)
> New Package SCM Request
> =======================
> Package Name: perl-File-KeePass
> Short Description: Interface to KeePass V1 and V2 database files
> Owners: delete echevemaster
> Branches: f18 f19 f20 el5 el6
> InitialCC:

Please add 
InitialCC: perl-sig
cf. http://fedoraproject.org/wiki/Packaging:Perl


Jon, could you please make checking for this part of your routine job? Seems as if this isn't mentioned prominently enough in the Guidelines, which lets new-comers and infrequent perl-packagers miss this? TIA.
Comment 17 Fedora Update System 2013-09-21 04:34:04 EDT
perl-File-KeePass-2.03-3.fc19 has been pushed to the Fedora 19 stable repository.
Comment 18 Fedora Update System 2013-09-21 04:35:43 EDT
perl-File-KeePass-2.03-3.fc18 has been pushed to the Fedora 18 stable repository.
Comment 19 Fedora Update System 2013-09-22 20:24:43 EDT
perl-File-KeePass-2.03-3.fc20 has been pushed to the Fedora 20 stable repository.
Comment 20 Fedora Update System 2013-10-22 15:06:13 EDT
perl-File-KeePass-2.03-3.el6 has been pushed to the Fedora EPEL 6 stable repository.
Comment 21 Matías Kreder 2014-03-03 10:07:58 EST
Package Change Request
======================
Package Name: perl-File-KeePass
New Branches: epel7
Owners: delete
Comment 22 Gwyn Ciesla 2014-03-03 10:27:58 EST
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.